<?php

if( !function_exists('memory_get_usage') )
{
	function memory_get_usage()
	{
		//If its Windows
		//Tested on Win XP Pro SP2. Should work on Win 2003 Server too
		//Doesn't work for 2000
		//If you need it to work for 2000 look at http://us2.php.net/manual/en/function.memory-get-usage.php#54642
		if ( substr(PHP_OS,0,3) == 'WIN') {
			$output = array();
			exec( 'tasklist /FI "PID eq ' . getmypid() . '" /FO LIST', $output ); 
			return preg_replace( '/[\D]/', '', $output[5] ) * 1024;
		}else {
			//We now assume the OS is UNIX
			//Tested on Mac OS X 10.4.6 and Linux Red Hat Enterprise 4
			//This should work on most UNIX systems
			$pid = getmypid();
			exec("ps -eo%mem,rss,pid | grep $pid", $output);
			$output = explode("  ", $output[0]);
			//rss is given in 1024 byte units
			return $output[1] * 1024;
		}
	}
} 	


class wpsh_boot_loader {

	function wpsh_boot_loader() {
		$this->__construct();
	}
	
	function __construct() {
		$this->pure_init = !function_exists('add_action');
		$this->memory_limit = (int) $this->convert_ini_bytes(ini_get('memory_limit'));
		if($this->memory_limit == 0) $this->memory_limit = 1024*1024*1024; //no limit set to 1GB
		$this->check_points = array();
		if ($this->pure_init) {
			$this->_pass_checkpoint('boot:wp-config', 'PHP Runtime Boot', 'Will be passed if basic configuration values has been defined and WordPress tries it\'s boot sequence.');
		}else{
			$this->_pass_checkpoint('boot:wp-config', 'PHP Runtime Boot', 'If you want to know the pure amount of memory the PHP runtime has allocated, read the documentation about modification of <i>wp-config.php</i> to get a boot strip.');
			$this->check_points[0]['boot:wp-config']['mem'] = 0;
		}
	}
	
	function convert_ini_bytes($value) {
		if ( is_numeric( $value ) ) {
			return $value;
		} else {
			$value_length = strlen( $value );
			$qty = substr( $value, 0, $value_length - 1 );
			$unit = strtolower( substr( $value, $value_length - 1 ) );
			switch ( $unit ) {
				case 'k':
					$qty *= 1024;
					break;
				case 'm':
					$qty *= 1048576;
					break;
				case 'g':
					$qty *= 1073741824;
					break;
			}
			return $qty;
		}		
	}
	
	function convert_ini_bool($value) {
		$value = strtolower($value);
		if (empty($value) || $value == 'off') 
			return 'Off';
		if ($value == '1' || $value == 'on')
			return 'On';
		return '-n.a.-';
	}
	
	function convert_const_bool($value) {
		if (defined($value) && constant($value))
			return 'On';
		return 'Off';
	}

	function pass_checkpoint_system_health() {
			$this->_pass_checkpoint('boot:plugin', 'System Health Boot', 'Will be passed if this monitoring plugin has been loaded successful.');
		}
	
	function pass_checkpoint_plugins_loaded() {
		$this->_pass_checkpoint('hook:plugins_loaded', 'Plugins Active', 'Will be passed if all active plugins have been loaded successful.');
	}
	function pass_checkpoint_setup_themes() {
		$this->_pass_checkpoint('hook:setup_theme', 'Theme / Widgets', 'Will be passed if the Theme and Widget Factory has been initialized.');
	}
	function pass_checkpoint_gettext($loaded) {
		$this->_pass_checkpoint('hook:gettext', 'Localization File', 'Will be passed if the WordPress language file has been loaded successful.');
		if (!$loaded) $this->check_points[count($this->check_points)-1]['hook:gettext']['mem'] = 0;
	}
	function pass_checkpoint_init() {
		$this->_pass_checkpoint('hook:init', 'Init WordPress', 'Will be passed if WordPress initialization has been finished.');
	}
	function pass_checkpoint_admin_init() {
		$this->_pass_checkpoint('hook:admin_init', 'Init Admin Center', 'Will be passed if Admin Center initialization has been finished.');
	}
	
	
	function _pass_checkpoint($token, $title, $desc) {
		$this->check_points[] = array($token => array('mem' => memory_get_usage(), 'title' => $title, 'desc' => $desc));
	}
	
}

$wpsh_boot_loader = new wpsh_boot_loader();

?>